#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_vip_config.h"
std::auto_ptr<M_vip_config> M_vip_config::msSingleton(nullptr);

int M_vip_config::GetCount()
{
	return (int)mMapData.size();
}

const M_vip_configData* M_vip_config::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_vip_configData>& M_vip_config::GetMapData()
{
	return mMapData;
}

void M_vip_config::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_vip_config.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_vip_configData data;
		data.mID = element->IntAttribute("ID");
		data.mleve = element->IntAttribute("leve");
		data.mvipexp = element->IntAttribute("vipexp");
		{
			const char* everdayreward = element->Attribute("everdayreward");
			std::vector<std::string> veceverdayreward;
			boost::split(veceverdayreward, everdayreward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < veceverdayreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(veceverdayreward[i].c_str(), &temp))
				{
					data.meverdayreward.push_back(temp);
				}
			}
		}
		data.mskillquantity = element->IntAttribute("skillquantity");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_vip_config Loaded. Load Data:%u", mMapData.size());
}

void M_vip_config::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_vip_config");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_vip_config");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_vip_configData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "leve", data.mleve);
		LuaCfgHelper::readInt(L, "vipexp", data.mvipexp);
		LuaCfgHelper::readVectorInt(L, "everdayreward", data.meverdayreward);
		LuaCfgHelper::readInt(L, "skillquantity", data.mskillquantity);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_vip_config Loaded. Load Data:%u", mMapData.size());
}

void M_vip_config::Reload()
{
	mMapData.clear();
	Load();
}

M_vip_config* M_vip_config::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_vip_config());
	}
	return msSingleton.get();
}

void M_vip_config::Release()
{
	msSingleton.reset(nullptr);
}
